<?php

require_once "./ytx.Config.php";

class ytx {

    private $arr_post = array();
    private $ytx_url = serverUrl . version . "/sid/";
    private $arrAction = array("callDailBack" => "/call/DailbackCall.wx","getCdrByResId" => "/call/CallCdr.wx","getCdrByTime" => "/call/CallCdr.wx", "callOutCode" => "/call/CodeCallOut.wx", "createMeeting" => "/call/TeleMeeting.wx", "destroyMeeting" => "/call/TeleMeeting.wx", "flowOrder" => "/traffic/Traffic.wx", "inviteJoinMeeting" => "/call/TeleMeeting.wx", "templateSms" => "/sms/TemplateSMS.wx", "queryMeeting" => "/call/TeleMeeting.wx");

    function http_post_data($url, $data_string, $authorization) {

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json; charset=utf-8',
            'Content-Length: ' . strlen($data_string),
            'Authorization:' . $authorization
                )
        );
        ob_start();
        curl_exec($ch);
        $return_content = ob_get_contents();
        ob_end_clean();

        return $return_content;
    }

    function post() {
        $this->arr_post['appid'] = appID;
        $data_string = json_encode($this->arr_post);

        $timeYmdHis = date("YmdHis");
        $authorization = base64_encode(accountSID . "|{$timeYmdHis}");
        $sign = strtoupper(md5(accountSID . authToken . $timeYmdHis));
        $this->ytx_url .= accountSID . $this->arrAction[$this->arr_post['action']] . "?Sign={$sign}";

        echo $this->ytx_url, '<br/>', $data_string, '<br/>', $authorization, '<br/>';
        $ret = $this->http_post_data($this->ytx_url, $data_string, $authorization);

        return json_decode($ret, true);
    }

    function print_kv($arr) {
        if ($arr['statusCode'] === "0") {
            foreach ($arr as $key => $value) {
                echo "$key $value <br/>";
            }
        } else {
            print_r($arr);
        }
    }

    function callOutCode($dst, $code, $time, $dstclid, $voice) {
        $this->arr_post = null;
        $this->arr_post['action'] = "callOutCode";
        $this->arr_post['dst'] = $dst;
        $this->arr_post['code'] = $code;
        $this->arr_post['time'] = $time;
        $this->arr_post['dstclid'] = $dstclid;
        $this->arr_post['voice'] = $voice;
        return $this->post();
    }
    
     function callCdr ($action,$fid, $lastresid, $limit, $pdate, $ptime) {
        $this->arr_post = null;
        $this->arr_post['action'] = $action;
        $this->arr_post['fid'] = $fid;
        $this->arr_post['lastresid'] = $lastresid;
        $this->arr_post['limit'] = $limit;
        $this->arr_post['pdate'] = $pdate;
        $this->arr_post['ptime'] = $ptime;
        return $this->post();
    }

    function templateSms($mobile, $templateId, $datas) {
        $this->arr_post = null;
        $this->arr_post['action'] = "templateSms";
        $this->arr_post['mobile'] = $mobile;
        $this->arr_post['templateId'] = $templateId;
        $this->arr_post['datas'] = $datas;
        return $this->post();
    }

    function dailbackcall($src, $dst, $credit) {
        $this->arr_post = null;
        $this->arr_post['action'] = "callDailBack";
        $this->arr_post['src'] = $src;
        $this->arr_post['dst'] = $dst;
        $this->arr_post['credit'] = $credit;
        return $this->post();
    }

    function traffic($phone, $flowValue, $effectStartTime, $effectTime) {
        $this->arr_post = null;
        $this->arr_post['action'] = "flowOrder";
        $this->arr_post['phone'] = $phone;
        $this->arr_post['flowValue'] = $flowValue;
        $this->arr_post['effectStartTime'] = $effectStartTime;
        $this->arr_post['effectTime'] = $effectTime;
        return $this->post();
    }

    function createMeeting($creator, $parties, $credit) {
        $this->arr_post = null;
        $this->arr_post['action'] = "createMeeting";
        $this->arr_post['creator'] = $creator;
        $this->arr_post['parties'] = $parties;
        $this->arr_post['credit'] = $credit;
        return $this->post();
    }

    function inviteJoinMeeting($invitor, $parties, $confid) {
        $this->arr_post = null;
        $this->arr_post['action'] = "inviteJoinMeeting";
        $this->arr_post['invitor'] = $invitor;
        $this->arr_post['parties'] = $parties;
        $this->arr_post['confid'] = $confid;
        return $this->post();
    }

    function destroyMeeting($confid) {
        $this->arr_post = null;
        $this->arr_post['action'] = "destroyMeeting";
        $this->arr_post['confid'] = $confid;
        return $this->post();
    }

    function queryMeeting($confid) {
        $this->arr_post = null;
        $this->arr_post['action'] = "queryMeeting";
        $this->arr_post['confid'] = $confid;
        return $this->post();
    }

}
